Bug 2243345 - Review Request: bootc - Bootable container system
Summary: Review Request: bootc - Bootable container system
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Fabio Valentini
QA Contact: Fedora Extras Quality Assurance
URL: https://github.com/containers/bootc
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2023-10-11 20:30 UTC by Colin Walters
Modified: 2023-10-21 15:12 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2023-10-21 15:12:29 UTC
Type: ---
Embargoed:
decathorpe: fedora-review+


Attachments (Terms of Use)
The .spec file difference from Copr build 6517737 to 6517869 (2.47 KB, patch)
2023-10-11 22:31 UTC, Fedora Review Service
no flags Details | Diff

Description Colin Walters 2023-10-11 20:30:54 UTC
Spec URL: https://fedorapeople.org/~walters/bootc.spec
SRPM URL: https://fedorapeople.org/~walters/bootc-0.1.1-2.fc40.src.rpm
Description: Bootable container system
Fedora Account System Username: walters

Comment 1 Fedora Review Service 2023-10-11 20:36:45 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/6517737
(failed)

Build log:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2243345-bootc/fedora-rawhide-x86_64/06517737-bootc/builder-live.log.gz

Please make sure the package builds successfully at least for Fedora Rawhide.

- If the build failed for unrelated reasons (e.g. temporary network
  unavailability), please ignore it.
- If the build failed because of missing BuildRequires, please make sure they
  are listed in the "Depends On" field


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 2 Colin Walters 2023-10-11 21:12:28 UTC
fedora-review-service-build
(This is like some sort of really weird CI system...)

Comment 3 Fabio Valentini 2023-10-11 21:19:47 UTC
Quick comments:

1. There are duplicate Summary and License tags in the package, this seems unintentional?
The second ones are also likely subsumed by %description, having no effect (other than showing up in the package's %description, I guess).
The location of the %files section is also unusual, it's usually the last section, i.e. between %install (or %check, if present) and %changelog.

2. You're setting `%bcond_without check` (i.e. package is built *with* check), but you removed the %check section (or did not include it). If there are unit tests that can be run during the build, please add back this snippet:

%if %{with check}
%check
%cargo_test
%endif

3. If you have used rust2rpm v25 to generate this spec file, please keep the "# Generated by rust2rpm 25" line at the top. We use it to track which spec files were generated from outdated templates.

4. It looks like the build failure is caused by missing BuildRequires for "pkgconfig(glib-2.0)" (or glib2-devel?).

PS: Do you have a list of the crates are currently missing from Fedora, preventing this package from being built without vendored dependencies?

Comment 4 Fabio Valentini 2023-10-11 21:43:31 UTC
(On second glance, it looks like this was adapted from the rust-bootupd package, which explains the unusual structure and issues with duplicate License / Summary tags. Pointing rust2rpm at bootc-0.1.1/Cargo.toml should actually give you better results than that. :)

Comment 5 Colin Walters 2023-10-11 22:00:12 UTC
Thanks for the reply!

Spec URL: https://fedorapeople.org/~walters/bootc.spec
SRPM URL: https://fedorapeople.org/~walters/bootc-0.1.1-1.fc40.src.rpm

> PS: Do you have a list of the crates are currently missing from Fedora, preventing this package from being built without vendored dependencies?

Biggest is kube, a dependency which I am really debating because it's kind of massive overkill for what we need right now.
Though either way as you know it's important to me to keep this spec in sync with C9S.

> (On second glance, it looks like this was adapted from the rust-bootupd package, which explains the unusual structure and issues with duplicate License / Summary tags.

Yes indeed.  Fixed those thanks!
 
>  Pointing rust2rpm at bootc-0.1.1/Cargo.toml should actually give you better results than that. :)

It's a bit messier than that as it's split into sub-crates *internally* but I don't want to publish those to crates.io; looks like `cargo package` wants that.  I'm sure I could fake it out but...mmm, dunno.

Comment 6 Fabio Valentini 2023-10-11 22:19:16 UTC
(In reply to Colin Walters from comment #5)
> Thanks for the reply!
> 
> Spec URL: https://fedorapeople.org/~walters/bootc.spec
> SRPM URL: https://fedorapeople.org/~walters/bootc-0.1.1-1.fc40.src.rpm

Thanks, I'll take another look tomorrow. It's getting late.

> > PS: Do you have a list of the crates are currently missing from Fedora, preventing this package from being built without vendored dependencies?
> 
> Biggest is kube, a dependency which I am really debating because it's kind
> of massive overkill for what we need right now.
> Though either way as you know it's important to me to keep this spec in sync
> with C9S.

And I'm sure you know, Keeping the spec file in sync with C9S is an anti-goal, since different rules apply to Fedora and CentOS Stream.
The current spec file will also not build on ELN / RHEL, since the RHEL macros for Rust packaging diverge from the Fedora / EPEL macros.
Though it *should* build in epel9-next (i.e. EPEL on top of CentOS Stream 9).

> > (On second glance, it looks like this was adapted from the rust-bootupd package, which explains the unusual structure and issues with duplicate License / Summary tags.
> 
> Yes indeed.  Fixed those thanks!

:+1:

> >  Pointing rust2rpm at bootc-0.1.1/Cargo.toml should actually give you better results than that. :)
> 
> It's a bit messier than that as it's split into sub-crates *internally* but
> I don't want to publish those to crates.io; looks like `cargo package` wants
> that.  I'm sure I could fake it out but...mmm, dunno.

Faking things should not be necessary. rust2rpm has supported cargo workspaces for a while (and things not published on crates.io for *ages*) - pointing it at the toplevel Cargo.toml file from the uncompressed source tarball (i.e. literally "rust2rpm bootc-0.1.1/Cargo.toml") should just do "the right thing" (C).

Comment 7 Fedora Review Service 2023-10-11 22:31:49 UTC
Created attachment 1993539 [details]
The .spec file difference from Copr build 6517737 to 6517869

Comment 8 Fedora Review Service 2023-10-11 22:31:51 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/6517869
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2243345-bootc/fedora-rawhide-x86_64/06517869-bootc/fedora-review/review.txt

Please take a look if any issues were found.

---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 9 Colin Walters 2023-10-20 14:56:16 UTC
OK, I've now released 0.1.2 which at least drops the kube deps, though the biggest then is ostree-ext which then if we split into a separate source puts me in that super painful place I'm already in for ostree vs rpm-ostree around needing to do buildroot override dances etc.
(The sheer overhead per RPM really greatly incentivzes squashing)

New version also has man pages and some other fixes.
[fedora-review-service-build]

Comment 10 Fabio Valentini 2023-10-20 18:04:29 UTC
Spec URL: https://fedorapeople.org/~walters/bootc.spec
SRPM URL: https://fedorapeople.org/~walters/bootc-0.1.2-1.fc40.src.rpm

Triggering a new review service build without also posting the new links won't do anything :)

I'll finish up the review soon.

Comment 11 Fabio Valentini 2023-10-20 18:26:39 UTC
Two minor things:

1.

> %if %{with check}
> %check
> %cargo_test
> %endif

Why is this scriptlet before %prep? That's quite unusual, it's usually between %install and %files / %changelog.

2.

%{_prefix}/lib/bootc/00-defaults.toml

This looks like a configuration file. /usr/lib/ is really not the correct location for this?
It should be in either /usr/share/bootc/ (for package defaults) or in /etc/bootc/ (for custom system-wide settings).

Comment 12 Colin Walters 2023-10-20 20:30:05 UTC
> Why is this scriptlet before %prep? That's quite unusual, it's usually between %install and %files / %changelog.

Fixed 

> This looks like a configuration file. /usr/lib/ is really not the correct location for this?

Mmm, systemd uses /usr/lib/systemd for config files.  In the current https://uapi-group.org/specifications/specs/configuration_files_specification/
it's left open.  See also https://github.com/coreos/liboverdrop-rs/commit/6c899bcb3c5af823c3bb53fe774a7af6899edbc0 which we use.

Comment 13 Colin Walters 2023-10-20 20:35:14 UTC
(That said I've now done https://github.com/containers/bootc/pull/152 because we actually want it in downstream container images anyways)

Comment 14 Fabio Valentini 2023-10-20 21:00:16 UTC
Strange, but OK. In this case my last request is that the package owns the directory explicitly:

%{_prefix}/lib/bootc/ (note the trailing slash)

This prevents future headaches if this is ever replaced by a file (unlikely, but there's currently no workaround in RPM / DNF for replacing file / directory or the other way round, so best to avoid the situation entirely).

===

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
[~]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[?]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 8313 bytes in 1 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Rpmlint
-------
Checking: bootc-0.1.2-1.fc40.x86_64.rpm
          bootc-debuginfo-0.1.2-1.fc40.x86_64.rpm
          bootc-debugsource-0.1.2-1.fc40.x86_64.rpm
          bootc-0.1.2-1.fc40.src.rpm
============================ rpmlint session starts ============================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmp8cb4plr1')]
checks: 31, packages: 4

bootc.src: W: strange-permission bootc.spec 600
bootc.src: W: inconsistent-file-extension bootc-0.1.2-vendor.tar.zst
bootc.src: W: inconsistent-file-extension bootc-0.1.2.tar.zst
 4 packages and 0 specfiles checked; 0 errors, 3 warnings, 0 badness; has taken 0.9 s 




Rpmlint (debuginfo)
-------------------
Checking: bootc-debuginfo-0.1.2-1.fc40.x86_64.rpm
============================ rpmlint session starts ============================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpczdedwni')]
checks: 31, packages: 1

 1 packages and 0 specfiles checked; 0 errors, 0 warnings, 0 badness; has taken 0.4 s 





Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 31, packages: 3

 3 packages and 0 specfiles checked; 0 errors, 0 warnings, 0 badness; has taken 0.4 s 



Source checksums
----------------
https://github.com/containers/bootc/releases/download/v0.1.2/bootc-0.1.2-vendor.tar.zst :
  CHECKSUM(SHA256) this package     : 5e5967d939344d3b3bfa5bc80b59dcc57aa25329584e6289c084ec75b5d67b93
  CHECKSUM(SHA256) upstream package : 5e5967d939344d3b3bfa5bc80b59dcc57aa25329584e6289c084ec75b5d67b93
https://github.com/containers/bootc/releases/download/v0.1.2/bootc-0.1.2.tar.zst :
  CHECKSUM(SHA256) this package     : aedb18152aa334a5a03b18ea1b279b896494f6d28cb12944bd2d90b4cb01fff2
  CHECKSUM(SHA256) upstream package : aedb18152aa334a5a03b18ea1b279b896494f6d28cb12944bd2d90b4cb01fff2


Requires
--------
bootc (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libcrypto.so.3()(64bit)
    libcrypto.so.3(OPENSSL_3.0.0)(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_3.3)(64bit)
    libgcc_s.so.1(GCC_4.2.0)(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libm.so.6()(64bit)
    libostree-1.so.1()(64bit)
    libostree-1.so.1(LIBOSTREE_2016.3)(64bit)
    libostree-1.so.1(LIBOSTREE_2016.4)(64bit)
    libostree-1.so.1(LIBOSTREE_2016.8)(64bit)
    libostree-1.so.1(LIBOSTREE_2017.10)(64bit)
    libostree-1.so.1(LIBOSTREE_2017.15)(64bit)
    libostree-1.so.1(LIBOSTREE_2017.7)(64bit)
    libostree-1.so.1(LIBOSTREE_2018.3)(64bit)
    libostree-1.so.1(LIBOSTREE_2018.5)(64bit)
    libostree-1.so.1(LIBOSTREE_2020.1)(64bit)
    libostree-1.so.1(LIBOSTREE_2020.7)(64bit)
    libostree-1.so.1(LIBOSTREE_2021.1)(64bit)
    libostree-1.so.1(LIBOSTREE_2021.2)(64bit)
    libostree-1.so.1(LIBOSTREE_2021.4)(64bit)
    libssl.so.3()(64bit)
    libssl.so.3(OPENSSL_3.0.0)(64bit)
    libz.so.1()(64bit)
    libz.so.1(ZLIB_1.2.3.4)(64bit)
    rtld(GNU_HASH)

bootc-debuginfo (rpmlib, GLIBC filtered):

bootc-debugsource (rpmlib, GLIBC filtered):



Provides
--------
bootc:
    bootc
    bootc(x86-64)
    bundled(crate(addr2line))
    bundled(crate(adler))
    bundled(crate(aho-corasick))
    bundled(crate(ambient-authority))
    bundled(crate(android-tzdata))
    bundled(crate(android_system_properties))
    bundled(crate(anstream))
    bundled(crate(anstyle))
    bundled(crate(anstyle-parse))
    bundled(crate(anstyle-query))
    bundled(crate(anstyle-wincon))
    bundled(crate(anyhow))
    bundled(crate(async-compression))
    bundled(crate(autocfg))
    bundled(crate(backtrace))
    bundled(crate(base64))
    bundled(crate(bitflags))
    bundled(crate(block-buffer))
    bundled(crate(bumpalo))
    bundled(crate(bytes))
    bundled(crate(camino))
    bundled(crate(cap-primitives))
    bundled(crate(cap-std))
    bundled(crate(cap-std-ext))
    bundled(crate(cap-tempfile))
    bundled(crate(cc))
    bundled(crate(cfg-expr))
    bundled(crate(cfg-if))
    bundled(crate(chrono))
    bundled(crate(clap))
    bundled(crate(clap_builder))
    bundled(crate(clap_derive))
    bundled(crate(clap_lex))
    bundled(crate(clap_mangen))
    bundled(crate(colorchoice))
    bundled(crate(console))
    bundled(crate(containers-image-proxy))
    bundled(crate(core-foundation-sys))
    bundled(crate(cpufeatures))
    bundled(crate(crc32fast))
    bundled(crate(crypto-common))
    bundled(crate(darling))
    bundled(crate(darling_core))
    bundled(crate(darling_macro))
    bundled(crate(derive_builder))
    bundled(crate(derive_builder_core))
    bundled(crate(derive_builder_macro))
    bundled(crate(digest))
    bundled(crate(dyn-clone))
    bundled(crate(encode_unicode))
    bundled(crate(equivalent))
    bundled(crate(errno))
    bundled(crate(errno-dragonfly))
    bundled(crate(fastrand))
    bundled(crate(filetime))
    bundled(crate(flate2))
    bundled(crate(fn-error-context))
    bundled(crate(fnv))
    bundled(crate(foreign-types))
    bundled(crate(foreign-types-shared))
    bundled(crate(fs-set-times))
    bundled(crate(futures-channel))
    bundled(crate(futures-core))
    bundled(crate(futures-executor))
    bundled(crate(futures-io))
    bundled(crate(futures-macro))
    bundled(crate(futures-sink))
    bundled(crate(futures-task))
    bundled(crate(futures-util))
    bundled(crate(generic-array))
    bundled(crate(getrandom))
    bundled(crate(getset))
    bundled(crate(gimli))
    bundled(crate(gio))
    bundled(crate(gio-sys))
    bundled(crate(glib))
    bundled(crate(glib-macros))
    bundled(crate(glib-sys))
    bundled(crate(gobject-sys))
    bundled(crate(gvariant))
    bundled(crate(gvariant-macro))
    bundled(crate(hashbrown))
    bundled(crate(heck))
    bundled(crate(hermit-abi))
    bundled(crate(hex))
    bundled(crate(hmac))
    bundled(crate(iana-time-zone))
    bundled(crate(iana-time-zone-haiku))
    bundled(crate(ident_case))
    bundled(crate(indexmap))
    bundled(crate(indicatif))
    bundled(crate(instant))
    bundled(crate(io-extras))
    bundled(crate(io-lifetimes))
    bundled(crate(ipnet))
    bundled(crate(itoa))
    bundled(crate(js-sys))
    bundled(crate(lazy_static))
    bundled(crate(libc))
    bundled(crate(liboverdrop))
    bundled(crate(libsystemd))
    bundled(crate(libz-sys))
    bundled(crate(linux-raw-sys))
    bundled(crate(log))
    bundled(crate(matchers))
    bundled(crate(maybe-owned))
    bundled(crate(memchr))
    bundled(crate(memoffset))
    bundled(crate(minimal-lexical))
    bundled(crate(miniz_oxide))
    bundled(crate(mio))
    bundled(crate(nix))
    bundled(crate(nom))
    bundled(crate(nu-ansi-term))
    bundled(crate(num-traits))
    bundled(crate(number_prefix))
    bundled(crate(object))
    bundled(crate(oci-spec))
    bundled(crate(olpc-cjson))
    bundled(crate(once_cell))
    bundled(crate(openssl))
    bundled(crate(openssl-macros))
    bundled(crate(openssl-sys))
    bundled(crate(ostree))
    bundled(crate(ostree-ext))
    bundled(crate(ostree-sys))
    bundled(crate(overload))
    bundled(crate(pin-project))
    bundled(crate(pin-project-internal))
    bundled(crate(pin-project-lite))
    bundled(crate(pin-utils))
    bundled(crate(pkg-config))
    bundled(crate(portable-atomic))
    bundled(crate(ppv-lite86))
    bundled(crate(proc-macro-crate))
    bundled(crate(proc-macro-error))
    bundled(crate(proc-macro-error-attr))
    bundled(crate(proc-macro2))
    bundled(crate(quote))
    bundled(crate(rand))
    bundled(crate(rand_chacha))
    bundled(crate(rand_core))
    bundled(crate(redox_syscall))
    bundled(crate(ref-cast))
    bundled(crate(ref-cast-impl))
    bundled(crate(regex))
    bundled(crate(regex-automata))
    bundled(crate(regex-syntax))
    bundled(crate(roff))
    bundled(crate(rustc-demangle))
    bundled(crate(rustix))
    bundled(crate(ryu))
    bundled(crate(schemars))
    bundled(crate(schemars_derive))
    bundled(crate(semver))
    bundled(crate(serde))
    bundled(crate(serde_derive))
    bundled(crate(serde_derive_internals))
    bundled(crate(serde_json))
    bundled(crate(serde_spanned))
    bundled(crate(serde_with))
    bundled(crate(serde_with_macros))
    bundled(crate(serde_yaml))
    bundled(crate(sha2))
    bundled(crate(sharded-slab))
    bundled(crate(signal-hook-registry))
    bundled(crate(slab))
    bundled(crate(smallvec))
    bundled(crate(socket2))
    bundled(crate(strsim))
    bundled(crate(subtle))
    bundled(crate(syn))
    bundled(crate(system-deps))
    bundled(crate(tar))
    bundled(crate(target-lexicon))
    bundled(crate(tempfile))
    bundled(crate(terminal_size))
    bundled(crate(thiserror))
    bundled(crate(thiserror-impl))
    bundled(crate(thread_local))
    bundled(crate(tinyvec))
    bundled(crate(tinyvec_macros))
    bundled(crate(tokio))
    bundled(crate(tokio-macros))
    bundled(crate(tokio-stream))
    bundled(crate(tokio-util))
    bundled(crate(toml))
    bundled(crate(toml_datetime))
    bundled(crate(toml_edit))
    bundled(crate(tracing))
    bundled(crate(tracing-attributes))
    bundled(crate(tracing-core))
    bundled(crate(tracing-log))
    bundled(crate(tracing-subscriber))
    bundled(crate(typenum))
    bundled(crate(unicode-ident))
    bundled(crate(unicode-normalization))
    bundled(crate(unicode-width))
    bundled(crate(unsafe-libyaml))
    bundled(crate(utf8parse))
    bundled(crate(uuid))
    bundled(crate(valuable))
    bundled(crate(vcpkg))
    bundled(crate(version-compare))
    bundled(crate(version_check))
    bundled(crate(wasi))
    bundled(crate(wasm-bindgen))
    bundled(crate(wasm-bindgen-backend))
    bundled(crate(wasm-bindgen-macro))
    bundled(crate(wasm-bindgen-macro-support))
    bundled(crate(wasm-bindgen-shared))
    bundled(crate(winapi))
    bundled(crate(winapi-i686-pc-windows-gnu))
    bundled(crate(winapi-x86_64-pc-windows-gnu))
    bundled(crate(windows))
    bundled(crate(windows-sys))
    bundled(crate(windows-targets))
    bundled(crate(windows_aarch64_gnullvm))
    bundled(crate(windows_aarch64_msvc))
    bundled(crate(windows_i686_gnu))
    bundled(crate(windows_i686_msvc))
    bundled(crate(windows_x86_64_gnu))
    bundled(crate(windows_x86_64_gnullvm))
    bundled(crate(windows_x86_64_msvc))
    bundled(crate(winnow))
    bundled(crate(winx))
    bundled(crate(xattr))
    bundled(crate(xshell))
    bundled(crate(xshell-macros))

bootc-debuginfo:
    bootc-debuginfo
    bootc-debuginfo(x86-64)
    debuginfo(build-id)

bootc-debugsource:
    bootc-debugsource
    bootc-debugsource(x86-64)



Diff spec file in url and in SRPM
---------------------------------
--- /home/deca/Downloads/2243345-bootc/srpm/bootc.spec	2023-10-20 20:06:47.357397886 +0200
+++ /home/deca/Downloads/2243345-bootc/srpm-unpacked/bootc.spec	2023-10-20 02:00:00.000000000 +0200
@@ -1,2 +1,12 @@
+## START: Set by rpmautospec
+## (rpmautospec version 0.3.5)
+## RPMAUTOSPEC: autorelease, autochangelog
+%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
+    release_number = 1;
+    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
+    print(release_number + base_release_number - 1);
+}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
+## END: Set by rpmautospec
+
 %bcond_without check
 
@@ -61,4 +71,4 @@
 
 %changelog
-%autochangelog
-
+* Fri Oct 20 2023 John Doe <packager> - 0.1.2-1
+- Uncommitted changes

===

Please take care to import the correct spec file when importing this package (i.e. the one that is *not* from the SRPM / has not been processed with rpmautospec).

If you want to switch to not building against vendored dependencies in the future, the Rust SIG should be able to help with packaging / maintaining missing dependencies (looks like there aren't many of those).

I would also recommend to turn on monitoring for this package on koschei.fedoraproject.org and set it up on release-monitoring.org.

Comment 15 Colin Walters 2023-10-20 21:04:37 UTC
> This prevents future headaches if this is ever replaced by a file (unlikely, but there's currently no workaround in RPM / DNF for replacing file / directory or the other way round, so best to avoid the situation entirely).

Sure, will do though note the irony here: bootc is generally only going to be installed in bootable container images (which currently use ostree as a backend).
container images (and ostree updates) have no such weakness - we have the ability to *transactionally swap* completely arbitrary filesystem trees.
Or stated another way, while bootc is shipped as an RPM, it won't be *updated* by dnf/rpm...

Comment 16 Fabio Valentini 2023-10-21 09:52:54 UTC
> Sure, will do though note the irony here:

Yes, the irony is not lost on me. :) Still, it's a good idea to make directory ownership explicit.

Comment 17 Fedora Admin user for bugzilla script actions 2023-10-21 14:30:20 UTC
The Pagure repository was created at https://src.fedoraproject.org/rpms/bootc


Note You need to log in before you can comment on or make changes to this bug.